package gg

import "surdeus.su/core/gg/mx"

// The type describes what
// a window camera object must implement.
type Camera interface {
	// Get the matrice to apply
	// camera's features.
	GetRealMatrice(Context) mx.Matrice

	// The way to convert from real to absolute.
	GetAbsMatrice(Context) mx.Matrice

	// The shaders to apply on
	// everything on the camera.
	GetShaderOptions() *ShaderOptions

	GetAbsWinSize(Context) mx.Vector
}

