package gg

type Drawing struct {
	Vertices []Vertice
}

// The interface describes anything that can be
// drawn. It will be drew corresponding to
// the layers order so the layer must be returned.
type Drawer interface {
	Draw(Context) *Drawing
	GetLayer() Layer
	IsVisible() bool
}

